#include <float.h>
#include <dos.h>
#include <conio.h>
#include <stdlib.h>
#include <stdarg.h>
#include <math.h>
#include <stdio.h>
#include "mtask.h"
#include "mutex.h"
#include "sem.h"

#define KBD_IRQ			1

Semaphore_t *kbd;
Mutex_t *mut;
double d;

static int
mgetch(void)
{
	int c;

	while ( true )
	{
		EnterMutex(mut);
		if ( kbhit() )
		{
			c = getch();
			LeaveMutex(mut);
			return c;
		}
		LeaveMutex(mut);
		WaitSem(kbd);
	}
}

static bool 
new_kbd(unsigned irq)
{
	SignalSem(kbd);
	return false;
}

static int
mprintf(char *format, ...)
{
	int n;
	va_list args;

	va_start(args, format);
	EnterMutex(mut);
	n = vprintf(format, args);
	LeaveMutex(mut);
	return n;
}

static double
do_math(char *who)
{
	double dd;
	bool diff;

	dd = 1.234567;
	dd += dd;
	dd *= 2;
	dd /= 2;
	dd -= 1.234567;
	diff = dd != d;

	if ( diff )
		mprintf("%s: %f %f\n", who, dd, d);
	return dd;
}

void
h(void *arg)
{
	while ( 1 )
		do_math("task");
}

int
main(int argc, char **argv)
{
	Task_t *other;
	int i = 0, c;
	extern int _8087;

	if ( argc > 3 )
		_8087 = atoi(argv[3]);

	InitMTask(0, 0);
	mut = CreateMutex("mut");
	kbd = CreateSem("kbd", 0);
	d = do_math("main");

	SetHandler(KBD_IRQ, new_kbd);

	printf("main: _8087=%d\n", _8087);
	other = CreateTask(h, 4000, NULL, "task h", DEFAULT_PRIO-1);

	if ( argc > 1 && atoi(argv[1]) )
		ProtectMath(CurrentTask());
	if ( argc > 2 && atoi(argv[2]) )
		ProtectMath(other);

	Ready(other);
	while ( true )
	{
		if ( (c = mgetch()) == 'q' || c == 'Q')
			return 0;
		mprintf("main: do_math %d\n", ++i);
		do_math("main");
	}
}
